## charliecloud 0.2.3~git20171120.1a5609e

=== Makefile ===
SHELL=/bin/bash

# Add some good stuff to CFLAGS.
export CFLAGS += -std=c11 -Wall

.PHONY: all
all: VERSION.full bin/version.h bin/version.sh
	cd bin && $(MAKE) SETUID=$(SETUID) all
	cd test && $(MAKE) all
	cd examples/syscalls && $(MAKE) all

.PHONY: clean
clean:
	cd bin && $(MAKE) clean
	cd test && $(MAKE) clean
	cd examples/syscalls && $(MAKE) clean

# VERSION.full contains the version string reported by the executables.
#
# * If VERSION is an unadorned release (e.g. 0.2.3 not 0.2.3~pre), or there's
#   no Git information available, VERSION.full is simply a copy of VERSION.
#
# * Otherwise, we add the Git commit and a note if the working directory
#   contains uncommitted changes, e.g. "0.2.3~pre+ae24a4e.dirty".
#
ifeq ($(shell test -d .git && fgrep -q \~ VERSION && echo true),true)
.PHONY: VERSION.full  # depends on git metadata, not a simple file
VERSION.full:
	printf '%s+%s%s\n' \
	       $$(cat VERSION) \
	       $$(git rev-parse --short HEAD) \
	       $$(git diff-index --quiet HEAD || echo '.dirty') \
	       > VERSION.full
else
VERSION.full: VERSION
	cp VERSION VERSION.full
endif
bin/version.h: VERSION.full
	echo "#define VERSION \"$$(cat $<)\"" > $@
bin/version.sh: VERSION.full
	echo "version () { echo 1>&2 '$$(cat $<)'; }" > $@

# Yes, this is bonkers. We keep it around even though normal "git archive" or
# the zip files on Github work, because it provides an easy way to create a
# self-contained tarball with embedded Bats.
.PHONY: export
export: VERSION.full
	test -d .git -a -f test/bats/.git  # need recursive Git checkout
	git diff-index --quiet HEAD        # need clean working directory
	git archive HEAD --prefix=charliecloud-$$(cat VERSION.full)/ \
                         -o main.tar
	cd test/bats && \
          git archive HEAD \
            --prefix=charliecloud-$$(cat ../../VERSION.full)/test/bats/ \
            -o ../../bats.tar
	tar Af main.tar bats.tar
	tar --xform=s,^,charliecloud-$$(cat VERSION.full)/, \
            -rf main.tar \
            VERSION.full
	gzip -9 main.tar
	mv main.tar.gz charliecloud-$$(cat VERSION.full).tar.gz
	rm bats.tar
	ls -lh charliecloud-$$(cat VERSION.full).tar.gz

# PREFIX is the prefix expected at runtime (usually /usr or /usr/local for
#  system-wide installations).
#  More: https://www.gnu.org/prep/standards/html_node/Directory-Variables.html
#
# DESTDIR is the installation directory using during make install, which
#  usually coincides for manual installation, but is chosen to be a temporary
#  directory in packaging environments. PREFIX needs to be appended.
#  More: https://www.gnu.org/prep/standards/html_node/DESTDIR.html
#
# Reasoning here: Users performing manual install *have* to specify PREFIX;
# default is to use that also for DESTDIR. If DESTDIR is provided in addition,
# we use that for installation.
#
INSTALL_PREFIX := $(if $(DESTDIR),$(DESTDIR)/$(PREFIX),$(PREFIX))
BIN := $(INSTALL_PREFIX)/bin
DOC := $(INSTALL_PREFIX)/share/doc/charliecloud
TEST := $(DOC)/test
# LIBEXEC_DIR is modeled after FHS 3.0 and
# https://www.gnu.org/prep/standards/html_node/Directory-Variables.html. It
# contains any executable helpers that are not needed in PATH. Default is
# libexec/charliecloud which will be preprended with the PREFIX.
LIBEXEC_DIR ?= libexec/charliecloud
LIBEXEC_INST := $(INSTALL_PREFIX)/$(LIBEXEC_DIR)
LIBEXEC_RUN := $(PREFIX)/$(LIBEXEC_DIR)
.PHONY: install
install: all
	@test -n "$(PREFIX)" || \
          (echo "No PREFIX specified. Lasciando ogni speranza." && false)
	@echo Installing in $(INSTALL_PREFIX)
#       binaries
	install -d $(BIN)
	install -pm 755 -t $(BIN) $$(find bin -type f -executable)
#       Modify scripts to relate to new libexec location.
	for scriptfile in $$(find bin -type f -executable -printf "%f\n"); do \
	    sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(BIN)/$${scriptfile}; \
	done
#       Install ch-run setuid if either SETUID=yes is specified or the binary
#       in the build directory is setuid.
	if [ -n "$(SETUID)" ]; then \
            if [ $$(id -u) -eq 0 ]; then \
	        chown root $(BIN)/ch-run; \
	        chmod u+s $(BIN)/ch-run; \
	    else \
	        sudo chown root $(BIN)/ch-run; \
	        sudo chmod u+s $(BIN)/ch-run; \
	    fi \
	elif [ -u bin/ch-run ]; then \
	    sudo chmod u+s $(BIN)/ch-run; \
	fi
#       executable helpers
	install -d $(LIBEXEC_INST)
	install -pm 644 -t $(LIBEXEC_INST) bin/base.sh bin/version.sh
	sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(LIBEXEC_INST)/base.sh
#       misc "documentation"
	install -d $(DOC)
	install -pm 644 -t $(DOC) COPYRIGHT LICENSE README.rst
#       examples
	for i in examples/syscalls examples/{serial,mpi,other}/*; do \
	    install -d $(DOC)/$$i; \
	    install -pm 644 -t $(DOC)/$$i $$i/*; \
	done
	chmod 755 $(DOC)/examples/serial/hello/hello.sh \
	          $(DOC)/examples/syscalls/pivot_root \
	          $(DOC)/examples/syscalls/userns
	find $(DOC)/examples -name Build -exec chmod 755 {} \;
#       tests
	install -d $(TEST)
	install -pm 644 -t $(TEST) test/*.bats test/common.bash test/Makefile
	install -pm 755 -t $(TEST) test/Build.*
	install -pm 644 -t $(TEST) test/Dockerfile.* test/Docker_Pull.*
	install -pm 755 -t $(TEST) test/make-perms-test
	install -d $(TEST)/chtest
	install -pm 644 -t $(TEST)/chtest test/chtest/*
	chmod 755 $(TEST)/chtest/Build $(TEST)/chtest/*.py
	ln -sf ../../../../bin $(TEST)/bin
#       Bats (if embedded)
	if [ -d test/bats/bin ]; then \
	    install -d $(TEST)/bats && \
	    install -pm 644 -t $(TEST)/bats test/bats/CONDUCT.md \
	                                    test/bats/LICENSE \
	                                    test/bats/README.md && \
	    install -d $(TEST)/bats/libexec && \
	    install -pm 755 -t $(TEST)/bats/libexec test/bats/libexec/* && \
	    install -d $(TEST)/bats/bin && \
	    ln -sf ../libexec/bats $(TEST)/bats/bin/bats && \
	    ln -sf bats/bin/bats $(TEST)/bats; \
	fi

=== bin/Makefile ===
bin := ch-run ch-ssh
src := $(wildcard *.c)
obj := $(src:.c=.o)

.PHONY: all
all: $(bin)

$(obj): charliecloud.h Makefile
$(bin): charliecloud.o

.PHONY: clean
clean:
	rm -Rf *.o $(bin)

ifdef SETUID
export CFLAGS += -DSETUID
all: setuid
setuid: ch-run
#	Use sudo only if not already root.
	if [ $$(id -u) -eq 0 ]; then \
	    chown root $<; \
	    chmod u+s $<; \
	elif ( command -v sudo >/dev/null 2>&1 && sudo -v >/dev/null 2>&1 ); then \
	    sudo chown root $<; \
	    sudo chmod u+s $<; \
	fi
endif

=== doc-src/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

# Help dumps from scripts
SCRIPTHELPS := $(addsuffix .help, \
	          $(subst ../bin/,,$(shell find ../bin -executable -type f)))

.PHONY: help clean html web dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

all: html

# All programs and scripts need to accept "--help", even if they normally use
# single-character flags only.
#
# Adding in $(SCRIPTHELPS) is voodoo to make the pattern work. Otherwise, it
# tries to build e.g. vm/vcluster.help from vm/../bin/vcluster. This is
# documented, but I didn't really understand. See
# http://stackoverflow.com/a/13552576/396038
$(SCRIPTHELPS): %.help: ../bin/%
	$< --help > $@ 2>&1

# Re-building programs in ch-run from here fails, so don't do it.
# FIXME: Rather than stopping the build, it continues with warnings. 
%.o : %.c
% : %.o
% : %.c

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*
	find . -name '*.help' -delete
	rm -rf ../doc/* ../doc/.buildinfo ../doc/.nojekyll

html: $(SCRIPTHELPS)
	$(SPHINXBUILD) -W -b html -D release="$$(cat ../VERSION)" -D version="$$(git rev-parse --short HEAD)" $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
	@echo
	rsync -a --delete --exclude-from RSYNC_EXCLUDE $(BUILDDIR)/html/ ../doc
	touch ../doc/.nojekyll
	@echo
	@echo "HTML pages copied to doc/."

# see http://stackoverflow.com/a/2659808/396038
web: html
	@echo
	@echo Making sure there are no uncommitted changes
	git diff-index --quiet --cached HEAD
	git diff-files --quiet
	@echo Can we talk to GitHub?
	cd ../doc && git ls-remote > /dev/null
	@echo Publishing new docs
	cd ../doc && git add --all
	cd ../doc && git commit -a -m "docs for commit $$(cd .. && git rev-parse --short HEAD)"
	cd ../doc && git push origin gh-pages

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/QUAC.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/QUAC.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/QUAC"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/QUAC"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== test/Makefile ===
export LC_ALL := C
IMAGES :=      chtest/Build \
               $(sort $(wildcard ./Build.*)) \
               $(sort $(wildcard ./Dockerfile.*)) \
               $(sort $(wildcard ./Docker_Pull.*)) \
               $(sort $(wildcard ../examples/*/*/Build)) \
               $(sort $(wildcard ../examples/*/*/Dockerfile)) \
               $(sort $(wildcard ../examples/*/*/Docker_Pull))
IMAGESQUICK := chtest/Build \
               Build.missing \
               Dockerfile.alpine36 \
               Docker_Pull.alpine36_dp
EXAMPLETESTS := $(sort $(wildcard ../examples/*/*/test.bats))
ifdef CH_TEST_OMIT
  EXAMPLETESTS := $(foreach i,$(EXAMPLETESTS),$(if $(findstring $(CH_TEST_OMIT),$(i)),,$(i)))
endif

# Favor embedded Bats, if installed, over system Bats.
export PATH := $(CURDIR)/bats/bin:$(PATH)

# Used by "make all" at top level to build these files for "make install".
.PHONY: all
all: build_auto.bats build_auto-quick.bats run_auto.bats run_auto-quick.bats

.PHONY: test
test: test-build test-run

.PHONY: test-all
test-all: test test-test

.PHONY: test-build
test-build: build_auto.bats
	bats build.bats build_auto.bats build_post.bats

# Note: This will will not find ch-run correctly if $CWD is not the test
# directory, which I believe is assumed elsewhere in the test suite as well.
.PHONY: test-run
test-run: run_auto.bats
	bats run.bats run_uidgid.bats run_auto.bats
	set -e; \
	if ( ! bin/ch-run --is-setuid ); then \
	for GUEST_USER in $$(id -un) root nobody; do \
	    for GUEST_GROUP in $$(id -gn) root $$(id -gn nobody); do \
	        export GUEST_USER; \
	        export GUEST_GROUP; \
	        echo testing as: $$GUEST_USER $$GUEST_GROUP; \
	        bats run_uidgid.bats; \
	    done; \
	done; fi

.PHONY: test-test
test-test: $(EXAMPLETESTS)
	bats $(EXAMPLETESTS)

.PHONY: test-quick
test-quick: build_auto-quick.bats run_auto-quick.bats
	bats build.bats build_auto-quick.bats run.bats run_uidgid.bats run_auto-quick.bats

.PHONY: clean
clean:
	rm -f *_auto*.bats

.PHONY: where-bats
where-bats:
	which bats
	bats --version

build_auto.bats: $(IMAGES)
	./make-auto build $^ > $@

build_auto-quick.bats: $(IMAGESQUICK)
	./make-auto build $^ > $@

run_auto.bats: $(IMAGES)
	./make-auto run $^ > $@

run_auto-quick.bats: $(IMAGESQUICK)
	./make-auto run $^ > $@

=== test/bats/man/Makefile ===
RONN := ronn
PAGES := bats.1 bats.7

all: $(PAGES)

bats.1: bats.1.ronn
	$(RONN) -r $<

bats.7: bats.7.ronn
	$(RONN) -r $<

=== debian/changelog ===
charliecloud (0.2.3~git20171120.1a5609e-2) unstable; urgency=medium

  * Switch Maintainer to Debian HPC team

 -- Lucas Nussbaum <lucas@debian.org>  Sun, 07 Jan 2018 16:56:19 +0100

charliecloud (0.2.3~git20171120.1a5609e-1) unstable; urgency=medium

  * Initial release (Closes: #882259)

 -- Lucas Nussbaum <lucas@debian.org>  Sun, 07 Jan 2018 09:35:19 +0100

=== debian/control ===
Source: charliecloud
Section: admin
Priority: optional
Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
Uploaders: Lucas Nussbaum <lucas@debian.org>
Build-Depends: debhelper (>= 11~),
               python,
               python-sphinx,
               python-sphinx-rtd-theme,
               rsync
Standards-Version: 4.1.3
Homepage: https://hpc.github.io/charliecloud/
Vcs-Git: https://salsa.debian.org/hpc-team/charliecloud.git
Vcs-Browser: https://salsa.debian.org/hpc-team/charliecloud/tree/master

Package: charliecloud
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Suggests: charliecloud-doc,
          docker.io
Description: user-defined software stacks (UDSS) for HPC centers
 Charliecloud provides user-defined software stacks (UDSS) (aka containers)
 for high-performance computing (HPC) centers. This "bring your own software
 stack" functionality addresses needs such as: software dependencies that are
 numerous, complex, unusual, differently configured, or simply newer/older
 than what the center provides; build-time requirements unavailable within
 the center, such as relatively unfettered internet access; validated
 software stacks and configuration to meet the standards of a particular
 field of inquiry; portability of environments between resources, including
 workstations and other test and development system not managed by the
 center; consistent environments, even archivally so, that can be easily,
 reliabily, and verifiably reproduced in the future; and/or usability and
 comprehensibility.

Package: charliecloud-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         libjs-mathjax,
         libjs-underscore,
         ${misc:Depends}
Description: user-defined software stacks (UDSS) for HPC centers (documentation)
 Charliecloud provides user-defined software stacks (UDSS) (aka containers)
 for high-performance computing (HPC) centers. This "bring your own software
 stack" functionality addresses needs such as: software dependencies that are
 numerous, complex, unusual, differently configured, or simply newer/older
 than what the center provides; build-time requirements unavailable within
 the center, such as relatively unfettered internet access; validated
 software stacks and configuration to meet the standards of a particular
 field of inquiry; portability of environments between resources, including
 workstations and other test and development system not managed by the
 center; consistent environments, even archivally so, that can be easily,
 reliabily, and verifiably reproduced in the future; and/or usability and
 comprehensibility.
 .
 This package provides documentation files for CharlieCloud.

=== debian/rules ===
#!/usr/bin/make -f

export PREFIX=/usr
export LIBEXEC_DIR=lib/charliecloud
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	dh_auto_build
	make -C doc-src
	mv doc html

override_dh_auto_clean:
	dh_auto_clean
	rm -rf VERSION.full bin/version.h bin/version.sh
	rm -rf html
	make -C doc-src clean

override_dh_auto_install:
	dh_auto_install
	rm -rf debian/tmp/usr/share/doc/charliecloud/test
	rm debian/tmp/usr/share/doc/charliecloud/COPYRIGHT
	rm debian/tmp/usr/share/doc/charliecloud/LICENSE
	# Patch out bundled jquery.js
	rm html/_static/jquery.js
	ln -s /usr/share/javascript/jquery/jquery.js html/_static/jquery.js
	# Patch out bundled underscore.js
	rm html/_static/underscore.js
	ln -s /usr/share/javascript/underscore/underscore.js html/_static/underscore.js
	# Patch out usage of MathJax CDN
	find html/*.html -type f -print0 | xargs -0 sed -i 's#https://cdn.mathjax.org/mathjax/latest/#/usr/share/javascript/mathjax/#g'
	find html/*.html -type f -print0 | xargs -0 sed -i 's#https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/#/usr/share/javascript/mathjax/#g'

## charliecloud 0.2.3

=== Makefile ===
--- 
+++ 
@@ -115,6 +115,11 @@
 	install -d $(LIBEXEC_INST)
 	install -pm 644 -t $(LIBEXEC_INST) bin/base.sh bin/version.sh
 	sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(LIBEXEC_INST)/base.sh
+#       man pages if they were built
+	if [ -f man/charliecloud.1 ]; then \
+	    install -d $(INSTALL_PREFIX)/share/man/man1; \
+	    install -pm 644 -t $(INSTALL_PREFIX)/share/man/man1 man/*.1; \
+	fi
 #       misc "documentation"
 	install -d $(DOC)
 	install -pm 644 -t $(DOC) COPYRIGHT LICENSE README.rst

=== doc-src/Makefile ===
--- 
+++ 
@@ -14,29 +14,9 @@
 # the i18n builder cannot share the environment and doctrees with the others
 I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
 
-# Help dumps from scripts
-SCRIPTHELPS := $(addsuffix .help, \
-	          $(subst ../bin/,,$(shell find ../bin -executable -type f)))
-
 .PHONY: help clean html web dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext
 
-all: html
-
-# All programs and scripts need to accept "--help", even if they normally use
-# single-character flags only.
-#
-# Adding in $(SCRIPTHELPS) is voodoo to make the pattern work. Otherwise, it
-# tries to build e.g. vm/vcluster.help from vm/../bin/vcluster. This is
-# documented, but I didn't really understand. See
-# http://stackoverflow.com/a/13552576/396038
-$(SCRIPTHELPS): %.help: ../bin/%
-	$< --help > $@ 2>&1
-
-# Re-building programs in ch-run from here fails, so don't do it.
-# FIXME: Rather than stopping the build, it continues with warnings. 
-%.o : %.c
-% : %.o
-% : %.c
+all: html man
 
 help:
 	@echo "Please use \`make <target>' where <target> is one of"
@@ -62,10 +42,10 @@
 
 clean:
 	rm -rf $(BUILDDIR)/*
-	find . -name '*.help' -delete
 	rm -rf ../doc/* ../doc/.buildinfo ../doc/.nojekyll
+	rm -rf ../man/*.1
 
-html: $(SCRIPTHELPS)
+html:
 	$(SPHINXBUILD) -W -b html -D release="$$(cat ../VERSION)" -D version="$$(git rev-parse --short HEAD)" $(ALLSPHINXOPTS) $(BUILDDIR)/html
 	@echo
 	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
@@ -75,7 +55,12 @@
 	@echo
 	@echo "HTML pages copied to doc/."
 
-# see http://stackoverflow.com/a/2659808/396038
+# Upload HTML documentation to the web via GitHub's Pages service [1]. Prevent
+# uploading if there are any uncommitted changes [2], to avoid placing docs
+# for work-in-progress in public.
+#
+# [1]: https://help.github.com/categories/github-pages-basics
+# [2]: http://stackoverflow.com/a/2659808
 web: html
 	@echo
 	@echo Making sure there are no uncommitted changes
@@ -156,9 +141,12 @@
 	@echo "Build finished. The text files are in $(BUILDDIR)/text."
 
 man:
-	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
+	$(SPHINXBUILD) -b man -D release="$$(cat ../VERSION)" -D version="$$(git rev-parse --short HEAD)" $(ALLSPHINXOPTS) $(BUILDDIR)/man
 	@echo
 	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."
+	@echo
+	cp $(BUILDDIR)/man/*.1 ../man
+	@echo "Man pages copied to man/."
 
 texinfo:
 	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo

=== debian/changelog ===
charliecloud (0.2.3-2) unstable; urgency=medium

  [ Peter Wienemann ]
  * Check unprivileged_userns_clone kernel setting with cat instead of sysctl

  [ Lucas Nussbaum ]
  * Prepare changelog for upload.

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 30 Apr 2018 15:41:33 +0200

charliecloud (0.2.3-1) unstable; urgency=medium

  [ Peter Wienemann ]
  * Restrict architecture to linux-any. Closes: #888395
  * Extend list of uploaders.
  * New upstream version 0.2.3.
  * Add man pages.
  * Display a warning if unprivileged user namespaces are disabled.

  [ Lucas Nussbaum ]
  * Prepare changelog for upload.

 -- Lucas Nussbaum <lucas@debian.org>  Tue, 24 Apr 2018 21:22:33 +0200

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
-Uploaders: Lucas Nussbaum <lucas@debian.org>
+Uploaders: Lucas Nussbaum <lucas@debian.org>, Peter Wienemann <wienemann@physik.uni-bonn.de>
 Build-Depends: debhelper (>= 11~),
+               po-debconf,
                python,
                python-sphinx,
                python-sphinx-rtd-theme,
@@ -14,7 +15,7 @@
 Vcs-Browser: https://salsa.debian.org/hpc-team/charliecloud/tree/master
 
 Package: charliecloud
-Architecture: any
+Architecture: linux-any
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Suggests: charliecloud-doc,

=== debian/rules ===
--- 
+++ 
@@ -20,6 +20,7 @@
 
 override_dh_auto_install:
 	dh_auto_install
+	dh_installdebconf
 	rm -rf debian/tmp/usr/share/doc/charliecloud/test
 	rm debian/tmp/usr/share/doc/charliecloud/COPYRIGHT
 	rm debian/tmp/usr/share/doc/charliecloud/LICENSE

## charliecloud 0.2.5

=== Makefile ===
--- 
+++ 
@@ -5,13 +5,14 @@
 
 .PHONY: all
 all: VERSION.full bin/version.h bin/version.sh
-	cd bin && $(MAKE) SETUID=$(SETUID) all
+	cd bin && $(MAKE) all
 	cd test && $(MAKE) all
 	cd examples/syscalls && $(MAKE) all
 
 .PHONY: clean
 clean:
 	cd bin && $(MAKE) clean
+	cd doc-src && $(MAKE) clean
 	cd test && $(MAKE) clean
 	cd examples/syscalls && $(MAKE) clean
 
@@ -25,15 +26,17 @@
 #
 ifeq ($(shell test -d .git && fgrep -q \~ VERSION && echo true),true)
 .PHONY: VERSION.full  # depends on git metadata, not a simple file
-VERSION.full:
+VERSION.full: VERSION
+	(git --version > /dev/null 2>&1) || \
+          (echo "This is a Git working directory but no git found." && false)
 	printf '%s+%s%s\n' \
-	       $$(cat VERSION) \
+	       $$(cat $<) \
 	       $$(git rev-parse --short HEAD) \
 	       $$(git diff-index --quiet HEAD || echo '.dirty') \
-	       > VERSION.full
+	       > $@
 else
 VERSION.full: VERSION
-	cp VERSION VERSION.full
+	cp $< $@
 endif
 bin/version.h: VERSION.full
 	echo "#define VERSION \"$$(cat $<)\"" > $@
@@ -42,11 +45,13 @@
 
 # Yes, this is bonkers. We keep it around even though normal "git archive" or
 # the zip files on Github work, because it provides an easy way to create a
-# self-contained tarball with embedded Bats.
+# self-contained tarball with embedded Bats and man pages.
+#
+# You must "cd doc-src && make" before this will work.
 .PHONY: export
-export: VERSION.full
+export: VERSION.full man/charliecloud.1
 	test -d .git -a -f test/bats/.git  # need recursive Git checkout
-	git diff-index --quiet HEAD        # need clean working directory
+#	git diff-index --quiet HEAD        # need clean working directory
 	git archive HEAD --prefix=charliecloud-$$(cat VERSION.full)/ \
                          -o main.tar
 	cd test/bats && \
@@ -56,7 +61,7 @@
 	tar Af main.tar bats.tar
 	tar --xform=s,^,charliecloud-$$(cat VERSION.full)/, \
             -rf main.tar \
-            VERSION.full
+            man/*.1 VERSION.full
 	gzip -9 main.tar
 	mv main.tar.gz charliecloud-$$(cat VERSION.full).tar.gz
 	rm bats.tar
@@ -75,6 +80,17 @@
 # default is to use that also for DESTDIR. If DESTDIR is provided in addition,
 # we use that for installation.
 #
+# PREFIX can be relative unless DESTDIR is set. Absolute paths are not
+# canonicalized.
+ifneq ($(PREFIX),)
+ifneq ($(shell echo "$(PREFIX)" | cut -c1),/)
+  ifdef DESTDIR
+    $(error PREFIX must be absolute if DESTDIR is set)
+  endif
+  override PREFIX := $(abspath $(PREFIX))
+  $(warning Relative PREFIX converted to $(PREFIX))
+endif
+endif
 INSTALL_PREFIX := $(if $(DESTDIR),$(DESTDIR)/$(PREFIX),$(PREFIX))
 BIN := $(INSTALL_PREFIX)/bin
 DOC := $(INSTALL_PREFIX)/share/doc/charliecloud
@@ -98,19 +114,6 @@
 	for scriptfile in $$(find bin -type f -executable -printf "%f\n"); do \
 	    sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(BIN)/$${scriptfile}; \
 	done
-#       Install ch-run setuid if either SETUID=yes is specified or the binary
-#       in the build directory is setuid.
-	if [ -n "$(SETUID)" ]; then \
-            if [ $$(id -u) -eq 0 ]; then \
-	        chown root $(BIN)/ch-run; \
-	        chmod u+s $(BIN)/ch-run; \
-	    else \
-	        sudo chown root $(BIN)/ch-run; \
-	        sudo chmod u+s $(BIN)/ch-run; \
-	    fi \
-	elif [ -u bin/ch-run ]; then \
-	    sudo chmod u+s $(BIN)/ch-run; \
-	fi
 #       executable helpers
 	install -d $(LIBEXEC_INST)
 	install -pm 644 -t $(LIBEXEC_INST) bin/base.sh bin/version.sh
@@ -122,7 +125,7 @@
 	fi
 #       misc "documentation"
 	install -d $(DOC)
-	install -pm 644 -t $(DOC) COPYRIGHT LICENSE README.rst
+	install -pm 644 -t $(DOC) LICENSE README.rst
 #       examples
 	for i in examples/syscalls examples/{serial,mpi,other}/*; do \
 	    install -d $(DOC)/$$i; \
@@ -140,8 +143,19 @@
 	install -pm 755 -t $(TEST) test/make-perms-test
 	install -d $(TEST)/chtest
 	install -pm 644 -t $(TEST)/chtest test/chtest/*
-	chmod 755 $(TEST)/chtest/Build $(TEST)/chtest/*.py
+	chmod 755 $(TEST)/chtest/{Build,*.py,printns}
 	ln -sf ../../../../bin $(TEST)/bin
+#       shared library tests
+	install -d $(TEST)/sotest $(TEST)/sotest/bin $(TEST)/sotest/lib
+	install -pm 755 -t $(TEST)/sotest test/sotest/files_inferrable.txt \
+	                                  test/sotest/files_noninferrable.txt \
+                                          test/sotest/libsotest.so.1.0 \
+	                                  test/sotest/sotest \
+	                                  test/sotest/sotest.c
+	ln -sf ./libsotest.so.1.0 $(TEST)/sotest/libsotest.so
+	ln -sf ./libsotest.so.1.0 $(TEST)/sotest/libsotest.so.1
+	install -pm 755 -t $(TEST)/sotest/bin test/sotest/bin/sotest
+	install -pm 755 -t $(TEST)/sotest/lib test/sotest/lib/libsotest.so.1.0
 #       Bats (if embedded)
 	if [ -d test/bats/bin ]; then \
 	    install -d $(TEST)/bats && \
@@ -154,3 +168,9 @@
 	    ln -sf ../libexec/bats $(TEST)/bats/bin/bats && \
 	    ln -sf bats/bin/bats $(TEST)/bats; \
 	fi
+
+.PHONY: deb
+deb:
+	ln -s packaging/debian
+	debuild -d -i -us -uc
+	rm -f debian

=== bin/Makefile ===
bin := ch-run ch-ssh
src := $(wildcard *.c)
obj := $(src:.c=.o)

CFLAGS += -pthread
LDLIBS += -pthread -lrt

.PHONY: all
all: $(bin)

$(obj): charliecloud.h Makefile
$(bin): charliecloud.o

.PHONY: clean
clean:
	rm -Rf *.o $(bin)

=== test/Makefile ===
export LC_ALL := C
IMAGES :=      chtest/Build \
               $(sort $(wildcard ./Build.*)) \
               $(sort $(wildcard ./Dockerfile.*)) \
               $(sort $(wildcard ./Docker_Pull.*)) \
               $(sort $(wildcard ../examples/*/*/Build)) \
               $(sort $(wildcard ../examples/*/*/Dockerfile)) \
               $(sort $(wildcard ../examples/*/*/Docker_Pull))
EXAMPLETESTS := $(sort $(wildcard ../examples/*/*/test.bats))

# Favor embedded Bats, if installed, over system Bats.
export PATH := $(CURDIR)/bats/bin:$(PATH)

# Used by "make all" at top level to build these files for "make install".
.PHONY: all
all: build_auto.bats run_auto.bats \
     sotest/bin/sotest sotest/lib/libsotest.so.1.0

.PHONY: test
test: test-build test-run test-test

.PHONY: test-build
test-build: build_auto.bats
	bats build.bats build_auto.bats build_post.bats

# Note: This will will not find ch-run correctly if $CWD is not the test
# directory, which I believe is assumed elsewhere in the test suite as well.
.PHONY: test-run
test-run: run_auto.bats
	bats run.bats run_uidgid.bats run_auto.bats run_join.bats run_post.bats
	set -e; \
        if [ "$$CH_TEST_SCOPE" != "quick" ]; then \
	for GUEST_USER in $$(id -un) root nobody; do \
	    for GUEST_GROUP in $$(id -gn) root $$(id -gn nobody); do \
	        export GUEST_USER; \
	        export GUEST_GROUP; \
	        echo testing as: $$GUEST_USER $$GUEST_GROUP; \
	        bats run_uidgid.bats; \
	    done; \
	done; fi

.PHONY: test-test
test-test: $(EXAMPLETESTS)
	bats $(EXAMPLETESTS)

.PHONY: clean
clean:
	rm -f *_auto.bats
	rm -f sotest/sotest sotest/libsotest.so*
	rm -f sotest/bin/sotest sotest/lib/libsotest.so*

.PHONY: where-bats
where-bats:
	which bats
	bats --version

build_auto.bats: $(IMAGES)
	./make-auto build $^ > $@

run_auto.bats: $(IMAGES)
	./make-auto run $^ > $@

sotest/bin/sotest: sotest/sotest
	cp -a $^ $@
sotest/lib/libsotest.so.1.0: sotest/libsotest.so.1.0
	cp -a $^ $@

sotest/sotest: sotest/sotest.c sotest/libsotest.so.1.0
	$(CC) -o $@ -L./sotest -lsotest $^
sotest/libsotest.so.1.0: sotest/libsotest.c
	$(CC) -o $@ -shared -fPIC -Wl,-soname,libsotest.so.1 -lc $^
	ln -f -s libsotest.so.1.0 sotest/libsotest.so
	ln -f -s libsotest.so.1.0 sotest/libsotest.so.1

=== debian/changelog ===
charliecloud (0.2.5-1) unstable; urgency=medium

  [ Alban Vidal ]
  * Change po-debconf service by systemctl
  * Update all po-debconf files with systemctl

  [ Jonathan Bustillos ]
  * Add Spanish translation of debconf template (closes: #900715)

  [ Peter Wienemann ]
  * Update po files due to update of debconf template
  * Update README.Debian to get description in sync with debconf template
  * Add debconf-updatepo to "clean" target in debian/rules file
  * charliecloud-doc: Mark package Multi-Arch: foreign
  * New upstream version 0.2.4
  * Adapt debian/rules file to upstream's removal of COPYRIGHT file
  * Remove duplicate doc-src clean-up in debian/rules
  * Add pv to the list of suggested packages for charliecloud
  * Switch to Standards-Version 4.1.4 (no changes required)
  * Update es.po file: Use systemctl to restart procps
  * New upstream version 0.2.5

 -- Lucas Nussbaum <lucas@debian.org>  Thu, 14 Jun 2018 16:27:40 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                python-sphinx,
                python-sphinx-rtd-theme,
                rsync
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://hpc.github.io/charliecloud/
 Vcs-Git: https://salsa.debian.org/hpc-team/charliecloud.git
 Vcs-Browser: https://salsa.debian.org/hpc-team/charliecloud/tree/master
@@ -19,7 +19,8 @@
 Depends: ${misc:Depends},
          ${shlibs:Depends}
 Suggests: charliecloud-doc,
-          docker.io
+          docker.io,
+          pv
 Description: user-defined software stacks (UDSS) for HPC centers
  Charliecloud provides user-defined software stacks (UDSS) (aka containers)
  for high-performance computing (HPC) centers. This "bring your own software
@@ -36,6 +37,7 @@
 
 Package: charliecloud-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: libjs-jquery,
          libjs-mathjax,

## charliecloud 0.9.0

=== debian/changelog ===
charliecloud (0.9.0-1) unstable; urgency=medium

  [ Lucas Nussbaum ]
  * Add missing changes to changelog entry for 0.2.5-1

  [ Peter Wienemann ]
  * changelog: Correct contributor of Russian translation
  * changelog: Remove duplicate entries
  * New upstream version 0.9.0

  [ Adriano Rafael Gomes ]
  * Add Brazilian Portuguese translation of debconf template (closes: #903354)

 -- Lucas Nussbaum <lucas@debian.org>  Mon, 16 Jul 2018 20:10:38 +0200

## charliecloud 0.9.1

=== Makefile ===
--- 
+++ 
@@ -21,16 +21,17 @@
 # * If VERSION is an unadorned release (e.g. 0.2.3 not 0.2.3~pre), or there's
 #   no Git information available, VERSION.full is simply a copy of VERSION.
 #
-# * Otherwise, we add the Git commit and a note if the working directory
-#   contains uncommitted changes, e.g. "0.2.3~pre+ae24a4e.dirty".
-#
+# * Otherwise, we add the Git branch if the current branch is not master, the 
+#   Git commit, and a note if the working directory
+#   contains uncommitted changes, e.g. "0.2.3~pre+experimental.ae24a4e.dirty".
 ifeq ($(shell test -d .git && fgrep -q \~ VERSION && echo true),true)
 .PHONY: VERSION.full  # depends on git metadata, not a simple file
 VERSION.full: VERSION
 	(git --version > /dev/null 2>&1) || \
           (echo "This is a Git working directory but no git found." && false)
-	printf '%s+%s%s\n' \
+	printf '%s+%s%s%s\n' \
 	       $$(cat $<) \
+	       $$(git rev-parse --abbrev-ref HEAD | sed 's/.*/&./g' | sed 's/master.//g') \
 	       $$(git rev-parse --short HEAD) \
 	       $$(git diff-index --quiet HEAD || echo '.dirty') \
 	       > $@
@@ -136,8 +137,9 @@
 	          $(DOC)/examples/syscalls/userns
 	find $(DOC)/examples -name Build -exec chmod 755 {} \;
 #       tests
-	install -d $(TEST)
+	install -d $(TEST) $(TEST)/run
 	install -pm 644 -t $(TEST) test/*.bats test/common.bash test/Makefile
+	install -pm 644 -t $(TEST)/run test/run/*.bats
 	install -pm 755 -t $(TEST) test/Build.*
 	install -pm 644 -t $(TEST) test/Dockerfile.* test/Docker_Pull.*
 	install -pm 755 -t $(TEST) test/make-perms-test

=== test/Makefile ===
--- 
+++ 
@@ -17,7 +17,10 @@
      sotest/bin/sotest sotest/lib/libsotest.so.1.0
 
 .PHONY: test
-test: test-build test-run test-test
+test: test-build test-run
+ifneq ($(CH_TEST_SCOPE),quick)
+test: test-test
+endif
 
 .PHONY: test-build
 test-build: build_auto.bats
@@ -27,7 +30,7 @@
 # directory, which I believe is assumed elsewhere in the test suite as well.
 .PHONY: test-run
 test-run: run_auto.bats
-	bats run.bats run_uidgid.bats run_auto.bats run_join.bats run_post.bats
+	bats run_first.bats run_auto.bats run/*.bats
 	set -e; \
         if [ "$$CH_TEST_SCOPE" != "quick" ]; then \
 	for GUEST_USER in $$(id -un) root nobody; do \
@@ -35,7 +38,7 @@
 	        export GUEST_USER; \
 	        export GUEST_GROUP; \
 	        echo testing as: $$GUEST_USER $$GUEST_GROUP; \
-	        bats run_uidgid.bats; \
+	        bats run/ch-run_uidgid.bats; \
 	    done; \
 	done; fi

=== debian/changelog ===
charliecloud (0.9.1-1) unstable; urgency=medium

  * New upstream version 0.9.1
  * Switch to Standards-Version 4.2.0 (no changes required)

 -- Peter Wienemann <wienemann@physik.uni-bonn.de>  Sat, 11 Aug 2018 22:22:31 +0200

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
                python-sphinx,
                python-sphinx-rtd-theme,
                rsync
-Standards-Version: 4.1.4
+Standards-Version: 4.2.0
 Homepage: https://hpc.github.io/charliecloud/
 Vcs-Git: https://salsa.debian.org/hpc-team/charliecloud.git
 Vcs-Browser: https://salsa.debian.org/hpc-team/charliecloud/tree/master

## charliecloud 0.9.2

=== debian/changelog ===
charliecloud (0.9.2-1) unstable; urgency=medium

  [ Helge Kreutzmann ]
  * Add German translation of debconf template (closes: #906186)

  [ Peter Wienemann ]
  * Update my email address in list of uploaders
  * New upstream version 0.9.2
  * Switch to Standards-Version 4.2.1 (no changes required)

 -- Peter Wienemann <fossdev@posteo.de>  Fri, 14 Sep 2018 22:19:32 +0200

## charliecloud 0.9.3

=== Makefile ===
--- 
+++ 
@@ -150,7 +150,6 @@
 #       shared library tests
 	install -d $(TEST)/sotest $(TEST)/sotest/bin $(TEST)/sotest/lib
 	install -pm 755 -t $(TEST)/sotest test/sotest/files_inferrable.txt \
-	                                  test/sotest/files_noninferrable.txt \
                                           test/sotest/libsotest.so.1.0 \
 	                                  test/sotest/sotest \
 	                                  test/sotest/sotest.c

=== doc-src/Makefile ===
--- 
+++ 
@@ -45,7 +45,14 @@
 	rm -rf ../doc/* ../doc/.buildinfo ../doc/.nojekyll
 	rm -rf ../man/*.1
 
-html:
+# This target works around a race condition in Sphinx that's triggered when
+# two instances (e.g., for html and man targets) try to mkdir(2)
+# _build/doctrees simultaneously. It is temporary and can be removed when
+# Sphinx >= 1.6.6 is an appropriate dependency. See issue #115.
+mkdir_issue115:
+	mkdir -p $(BUILDDIR)/doctrees
+
+html: mkdir_issue115
 	$(SPHINXBUILD) -W -b html -D release="$$(cat ../VERSION)" -D version="$$(git rev-parse --short HEAD)" $(ALLSPHINXOPTS) $(BUILDDIR)/html
 	@echo
 	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."
@@ -140,7 +147,7 @@
 	@echo
 	@echo "Build finished. The text files are in $(BUILDDIR)/text."
 
-man:
+man: mkdir_issue115
 	$(SPHINXBUILD) -b man -D release="$$(cat ../VERSION)" -D version="$$(git rev-parse --short HEAD)" $(ALLSPHINXOPTS) $(BUILDDIR)/man
 	@echo
 	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

=== debian/changelog ===
charliecloud (0.9.3-1) unstable; urgency=medium

  * Update debian/copyright file
    - Update years
    - Adjust indentation
    - Remove section for bats (it is not included in upstream tarballs)
    - Add section for Debian packaging
  * New upstream version 0.9.3

 -- Peter Wienemann <fossdev@posteo.de>  Sat, 06 Oct 2018 22:09:45 +0200

## charliecloud 0.9.4

=== Makefile ===
--- 
+++ 
@@ -113,12 +113,12 @@
 	install -pm 755 -t $(BIN) $$(find bin -type f -executable)
 #       Modify scripts to relate to new libexec location.
 	for scriptfile in $$(find bin -type f -executable -printf "%f\n"); do \
-	    sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(BIN)/$${scriptfile}; \
+	    sed -i "s#^libexec=.*#libexec=$(LIBEXEC_RUN)#" $(BIN)/$${scriptfile}; \
 	done
 #       executable helpers
 	install -d $(LIBEXEC_INST)
 	install -pm 644 -t $(LIBEXEC_INST) bin/base.sh bin/version.sh
-	sed -i "s#^LIBEXEC=.*#LIBEXEC=$(LIBEXEC_RUN)#" $(LIBEXEC_INST)/base.sh
+	sed -i "s#^libexec=.*#libexec=$(LIBEXEC_RUN)#" $(LIBEXEC_INST)/base.sh
 #       man pages if they were built
 	if [ -f man/charliecloud.1 ]; then \
 	    install -d $(INSTALL_PREFIX)/share/man/man1; \

=== test/Makefile ===
--- 
+++ 
@@ -1,12 +1,12 @@
 export LC_ALL := C
-IMAGES :=      chtest/Build \
-               $(sort $(wildcard ./Build.*)) \
-               $(sort $(wildcard ./Dockerfile.*)) \
-               $(sort $(wildcard ./Docker_Pull.*)) \
-               $(sort $(wildcard ../examples/*/*/Build)) \
-               $(sort $(wildcard ../examples/*/*/Dockerfile)) \
-               $(sort $(wildcard ../examples/*/*/Docker_Pull))
-EXAMPLETESTS := $(sort $(wildcard ../examples/*/*/test.bats))
+images :=   chtest/Build \
+            $(sort $(wildcard ./Build.*)) \
+            $(sort $(wildcard ./Dockerfile.*)) \
+            $(sort $(wildcard ./Docker_Pull.*)) \
+            $(sort $(wildcard ../examples/*/*/Build)) \
+            $(sort $(wildcard ../examples/*/*/Dockerfile)) \
+            $(sort $(wildcard ../examples/*/*/Docker_Pull))
+examples := $(sort $(wildcard ../examples/*/*/test.bats))
 
 # Favor embedded Bats, if installed, over system Bats.
 export PATH := $(CURDIR)/bats/bin:$(PATH)
@@ -43,8 +43,8 @@
 	done; fi
 
 .PHONY: test-test
-test-test: $(EXAMPLETESTS)
-	bats $(EXAMPLETESTS)
+test-test: $(examples)
+	bats $(examples)
 
 .PHONY: clean
 clean:
@@ -57,10 +57,10 @@
 	which bats
 	bats --version
 
-build_auto.bats: $(IMAGES)
+build_auto.bats: $(images)
 	./make-auto build $^ > $@
 
-run_auto.bats: $(IMAGES)
+run_auto.bats: $(images)
 	./make-auto run $^ > $@
 
 sotest/bin/sotest: sotest/sotest
@@ -68,9 +68,13 @@
 sotest/lib/libsotest.so.1.0: sotest/libsotest.so.1.0
 	cp -a $^ $@
 
+# We hardcode gcc here because some other compilers (hello, Intel) link the
+# resulting binaries with extra shared libraries that are then not copied into
+# the container. (Issue #227.)
+
 sotest/sotest: sotest/sotest.c sotest/libsotest.so.1.0
-	$(CC) -o $@ -L./sotest -lsotest $^
+	gcc -o $@ -L./sotest -lsotest $^
 sotest/libsotest.so.1.0: sotest/libsotest.c
-	$(CC) -o $@ -shared -fPIC -Wl,-soname,libsotest.so.1 -lc $^
+	gcc -o $@ -shared -fPIC -Wl,-soname,libsotest.so.1 -lc $^
 	ln -f -s libsotest.so.1.0 sotest/libsotest.so
 	ln -f -s libsotest.so.1.0 sotest/libsotest.so.1

=== examples/syscalls/Makefile ===
BINS := $(patsubst %.c,%,$(wildcard *.c))

.PHONY: all
all: $(BINS)

.PHONY: clean
clean:
	rm -f $(BINS)

$(BINS): Makefile

%: %.c
	gcc $(CFLAGS) $< -o $@

=== debian/changelog ===
charliecloud (0.9.4-1) unstable; urgency=medium

  * Fix lintian warning missing-license-paragraph-in-dep5-copyright
  * New upstream version 0.9.4

 -- Peter Wienemann <fossdev@posteo.de>  Sun, 18 Nov 2018 15:56:48 +0100

## charliecloud 0.9.5

=== test/Makefile ===
--- 
+++ 
@@ -1,12 +1,15 @@
 export LC_ALL := C
-images :=   chtest/Build \
-            $(sort $(wildcard ./Build.*)) \
-            $(sort $(wildcard ./Dockerfile.*)) \
-            $(sort $(wildcard ./Docker_Pull.*)) \
-            $(sort $(wildcard ../examples/*/*/Build)) \
-            $(sort $(wildcard ../examples/*/*/Dockerfile)) \
-            $(sort $(wildcard ../examples/*/*/Docker_Pull))
-examples := $(sort $(wildcard ../examples/*/*/test.bats))
+images_ch := chtest/Build \
+             $(sort $(wildcard ./Build.*)) \
+             $(sort $(wildcard ./Dockerfile.*)) \
+             $(sort $(wildcard ./Docker_Pull.*))
+images_eg := $(sort $(wildcard ../examples/*/*/Build)) \
+             $(sort $(wildcard ../examples/*/*/Build.*)) \
+             $(sort $(wildcard ../examples/*/*/Dockerfile)) \
+             $(sort $(wildcard ../examples/*/*/Dockerfile.*)) \
+             $(sort $(wildcard ../examples/*/*/Docker_Pull)) \
+             $(sort $(wildcard ../examples/*/*/Docker_Pull.*))
+images := $(images_ch) $(images_eg)
 
 # Favor embedded Bats, if installed, over system Bats.
 export PATH := $(CURDIR)/bats/bin:$(PATH)
@@ -42,9 +45,13 @@
 	    done; \
 	done; fi
 
+# FIXME: This could be sped up by skipping bats if the image is out of scope.
 .PHONY: test-test
-test-test: $(examples)
-	bats $(examples)
+test-test: $(images_eg)
+	for image in $(images_eg); do \
+	    export CH_TEST_TAG=$$(./make-auto tag $$image); \
+	    bats $$(dirname $$image)/test.bats; \
+	done
 
 .PHONY: clean
 clean:

=== debian/changelog ===
charliecloud (0.9.5-1) unstable; urgency=medium

  * New upstream version 0.9.5

 -- Peter Wienemann <fossdev@posteo.de>  Sat, 08 Dec 2018 22:19:36 +0100

## charliecloud 0.9.6

=== Makefile ===
--- 
+++ 
@@ -142,7 +142,7 @@
 	install -pm 644 -t $(TEST)/run test/run/*.bats
 	install -pm 755 -t $(TEST) test/Build.*
 	install -pm 644 -t $(TEST) test/Dockerfile.* test/Docker_Pull.*
-	install -pm 755 -t $(TEST) test/make-perms-test
+	install -pm 755 -t $(TEST) test/make-auto test/make-perms-test
 	install -d $(TEST)/chtest
 	install -pm 644 -t $(TEST)/chtest test/chtest/*
 	chmod 755 $(TEST)/chtest/{Build,*.py,printns}

=== test/chtest/Makefile ===
BINS := chroot-escape mknods setgroups setuid
ALL := $(BINS)
CFLAGS := -std=gnu11 -Wall

.PHONY: all
all: $(ALL)

.PHONY: clean
clean:
	rm -f $(ALL)

=== debian/changelog ===
charliecloud (0.9.6-1) unstable; urgency=medium

  * New upstream version 0.9.6

 -- Peter Wienemann <fossdev@posteo.de>  Fri, 14 Dec 2018 20:09:40 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Section: admin
 Priority: optional
 Maintainer: Debian HPC Team <debian-hpc@lists.debian.org>
-Uploaders: Lucas Nussbaum <lucas@debian.org>, Peter Wienemann <wienemann@physik.uni-bonn.de>
+Uploaders: Lucas Nussbaum <lucas@debian.org>, Peter Wienemann <fossdev@posteo.de>
 Build-Depends: debhelper (>= 11~),
                po-debconf,
                python,
                python-sphinx,
                python-sphinx-rtd-theme,
                rsync
-Standards-Version: 4.2.0
+Standards-Version: 4.2.1
 Homepage: https://hpc.github.io/charliecloud/
 Vcs-Git: https://salsa.debian.org/hpc-team/charliecloud.git
 Vcs-Browser: https://salsa.debian.org/hpc-team/charliecloud/tree/master

=== debian/rules ===
--- 
+++ 
@@ -16,13 +16,12 @@
 	dh_auto_clean
 	rm -rf VERSION.full bin/version.h bin/version.sh
 	rm -rf html
-	make -C doc-src clean
+	debconf-updatepo
 
 override_dh_auto_install:
 	dh_auto_install
 	dh_installdebconf
 	rm -rf debian/tmp/usr/share/doc/charliecloud/test
-	rm debian/tmp/usr/share/doc/charliecloud/COPYRIGHT
 	rm debian/tmp/usr/share/doc/charliecloud/LICENSE
 	# Patch out bundled jquery.js
 	rm html/_static/jquery.js
